"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getWidth = undefined;

var _map = require("ramda/src/map");

var _map2 = _interopRequireDefault(_map);

var _length = require("ramda/src/length");

var _length2 = _interopRequireDefault(_length);

var _subtract = require("ramda/src/subtract");

var _subtract2 = _interopRequireDefault(_subtract);

var _merge = require("ramda/src/merge");

var _merge2 = _interopRequireDefault(_merge);

var _without = require("ramda/src/without");

var _without2 = _interopRequireDefault(_without);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(["\n  position: absolute;\n  top: 5px;\n  left: 12.5px;\n  fill: #82888a;\n  width: 18px;\n"], ["\n  position: absolute;\n  top: 5px;\n  left: 12.5px;\n  fill: #82888a;\n  width: 18px;\n"]),
    _templateObject2 = _taggedTemplateLiteral(["\n  position: absolute;\n  top: 5px;\n  right: 12.5px;\n  fill: #82888a;\n  width: 18px;\n"], ["\n  position: absolute;\n  top: 5px;\n  right: 12.5px;\n  fill: #82888a;\n  width: 18px;\n"]),
    _templateObject3 = _taggedTemplateLiteral(["\n  position: relative;\n  margin: 0 auto;\n  text-align: center;\n  max-width: ", ";\n"], ["\n  position: relative;\n  margin: 0 auto;\n  text-align: center;\n  max-width: ", ";\n"]),
    _templateObject4 = _taggedTemplateLiteral(["\n  display: flex;\n"], ["\n  display: flex;\n"]),
    _templateObject5 = _taggedTemplateLiteral(["\n  border: 1px solid ", ";\n  position: absolute;\n  background: ", ";\n  border-radius: 2px;\n  width: 43px;\n  height: 30px;\n  cursor: pointer;\n  :hover {\n    background: ", ";\n  }\n  &:focus {\n    outline: none;\n  }\n  :disabled {\n    cursor: not-allowed;\n    :hover {\n      background: initial;\n    }\n  }\n"], ["\n  border: 1px solid ", ";\n  position: absolute;\n  background: ", ";\n  border-radius: 2px;\n  width: 43px;\n  height: 30px;\n  cursor: pointer;\n  :hover {\n    background: ", ";\n  }\n  &:focus {\n    outline: none;\n  }\n  :disabled {\n    cursor: not-allowed;\n    :hover {\n      background: initial;\n    }\n  }\n"]),
    _templateObject6 = _taggedTemplateLiteral(["\n  margin-right: 10px;\n  &:last-child {\n    margin-right: 0;\n  }\n"], ["\n  margin-right: 10px;\n  &:last-child {\n    margin-right: 0;\n  }\n"]),
    _templateObject7 = _taggedTemplateLiteral(["\n  left: 0;\n"], ["\n  left: 0;\n"]),
    _templateObject8 = _taggedTemplateLiteral(["\n  right: 0;\n"], ["\n  right: 0;\n"]);

var _react = require("react");

var React = _interopRequireWildcard(_react);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _eachDayOfInterval = require("date-fns/eachDayOfInterval");

var _eachDayOfInterval2 = _interopRequireDefault(_eachDayOfInterval);

var _isSameDay = require("date-fns/isSameDay");

var _isSameDay2 = _interopRequireDefault(_isSameDay);

var _isBefore = require("date-fns/isBefore");

var _isBefore2 = _interopRequireDefault(_isBefore);

var _startOfMonth = require("date-fns/startOfMonth");

var _startOfMonth2 = _interopRequireDefault(_startOfMonth);

var _endOfMonth = require("date-fns/endOfMonth");

var _endOfMonth2 = _interopRequireDefault(_endOfMonth);

var _CalendarMonth = require("./CalendarMonth");

var _CalendarMonth2 = _interopRequireDefault(_CalendarMonth);

var _ArrowLeft = require("./ArrowLeft");

var _ArrowLeft2 = _interopRequireDefault(_ArrowLeft);

var _ArrowRight = require("./ArrowRight");

var _ArrowRight2 = _interopRequireDefault(_ArrowRight);

var _utils = require("./utils");

var utils = _interopRequireWildcard(_utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var defaultColors = {
  selected: "rgb(244, 114, 49)",
  selectedHover: "rgb(255, 141, 74)",
  border: "#e4e7e7",
  background: "white",
  hover: "#e4e7e7",
  disabled: "gray"
};

var StyledArrowLeft = (0, _styledComponents2.default)(_ArrowLeft2.default)(_templateObject);

var StyledArrowRight = (0, _styledComponents2.default)(_ArrowRight2.default)(_templateObject2);

var getWidth = exports.getWidth = function getWidth(number) {
  if (number === 1) {
    return "301px";
  }
  return number * 301 + "px"; // 311 - 10 = 301 : 10 = margin
};

var CalendarWrapper = _styledComponents2.default.div(_templateObject3, function (props) {
  return getWidth(props.visibleMonths);
});

var CalendarMonthWrapper = _styledComponents2.default.div(_templateObject4);

var NavBtn = _styledComponents2.default.button(_templateObject5, function (props) {
  return props.colors.border;
}, function (props) {
  return props.colors.background;
}, function (props) {
  return props.colors.border;
});

var StyledMonth = (0, _styledComponents2.default)(_CalendarMonth2.default)(_templateObject6);

var PrevBtn = NavBtn.extend(_templateObject7);

var NextBtn = NavBtn.extend(_templateObject8);

var Calendar = function (_React$PureComponent) {
  _inherits(Calendar, _React$PureComponent);

  function Calendar(props) {
    _classCallCheck(this, Calendar);

    var _this = _possibleConstructorReturn(this, (Calendar.__proto__ || Object.getPrototypeOf(Calendar)).call(this, props));

    _this.handleNext = function () {
      _this.setState(function (state) {
        return {
          currentMonth: state.currentMonth + 1
        };
      });
    };

    _this.handlePrev = function () {
      _this.setState(function (state) {
        return {
          currentMonth: state.currentMonth - 1
        };
      });
    };

    _this.handleSetCurrentMonth = function (nextProps, nextState) {
      var _this$props = _this.props,
          firstMonth = _this$props.firstMonth,
          lastMonth = _this$props.lastMonth,
          future = _this$props.future,
          visibleMonths = _this$props.visibleMonths;
      // if date wasn't selected internally (it means that selectedDates
      // was changed from parent component ) then calculate current month and set it
      // also set selectedInternally to false

      if (!nextState.selectedInternally) {
        var currentMonth = utils.getCurrentMonthIndex(firstMonth, lastMonth, nextProps.selectedDates, future, visibleMonths);
        // eslint-disable-next-line react/no-unused-state
        _this.setState({ selectedInternally: false, currentMonth: currentMonth });
        // }
        // otherwise just set selectedInternally to false, so we can determine if next
        // date select will be done in this component or in parent component
      } else {
        // eslint-disable-next-line react/no-unused-state
        _this.setState({ selectedInternally: false });
      }
    };

    _this.handleSetRange = function (date) {
      var start = _this.state.start;
      var disabledDates = _this.props.disabledDates;
      // when someting is already selected (start)
      // and we clicked on some date (date)
      // then we will set array of dates between
      // date and start - it depends which one is first
      // selected array of dates is sorted ascending

      if (date && start) {
        // eslint-disable-next-line react/no-unused-state
        _this.setState({ selectedInternally: true });
        if ((0, _isBefore2.default)(date, start)) {
          var range = (0, _eachDayOfInterval2.default)({ start: date, end: start });
          _this.props.selectDates((0, _without2.default)(disabledDates, range));
        } else {
          var _range = (0, _eachDayOfInterval2.default)({ start: start, end: date });
          _this.props.selectDates((0, _without2.default)(disabledDates, _range));
        }
      }
    };

    _this.handleSelect = function (date) {
      var _this$props2 = _this.props,
          disabledDates = _this$props2.disabledDates,
          rangeSelect = _this$props2.rangeSelect;
      var _this$state = _this.state,
          isFocused = _this$state.isFocused,
          end = _this$state.end,
          start = _this$state.start;
      // when something is already selected

      if (isFocused && rangeSelect) {
        _this.setState({
          end: date,
          isFocused: false,
          hoveredDates: [],
          // eslint-disable-next-line react/no-unused-state
          selectedInternally: true
        });
        _this.handleSetRange(date);
        // when unselecting date
      } else if (
      // $FlowExpected
      (0, _isSameDay2.default)(date, end) &&
      // $FlowExpected
      (0, _isSameDay2.default)(end, start)) {
        _this.setState({
          start: null,
          end: null,
          isFocused: false,
          // eslint-disable-next-line react/no-unused-state
          selectedInternally: true
        });
        _this.props.selectDates([]);
        // initial select case
      } else {
        _this.setState({
          start: date,
          isFocused: true,
          // eslint-disable-next-line react/no-unused-state
          selectedInternally: true
        });
        _this.props.selectDates((0, _without2.default)(disabledDates, [date]));
      }
    };

    _this.handleHover = function (date) {
      var rangeSelect = _this.props.rangeSelect;
      var _this$state2 = _this.state,
          isFocused = _this$state2.isFocused,
          start = _this$state2.start;

      if (start && date && isFocused && rangeSelect) {
        if ((0, _isBefore2.default)(date, start)) {
          _this.setState({
            hoveredDates: (0, _eachDayOfInterval2.default)({ start: date, end: start })
          });
        } else {
          _this.setState({
            hoveredDates: (0, _eachDayOfInterval2.default)({
              start: start,
              end: date
            })
          });
        }
      }
    };

    _this.state = {
      end: null,
      hoveredDates: [],
      currentMonth: utils.getCurrentMonthIndex(props.firstMonth, props.lastMonth, props.selectedDates, props.future, props.visibleMonths),
      isFocused: false,
      start: null,
      // eslint-disable-next-line react/no-unused-state
      selectedInternally: false
    };
    return _this;
  }

  _createClass(Calendar, [{
    key: "componentWillUpdate",
    value: function componentWillUpdate(nextProps, nextState) {
      // when selectedDates came as a props, we need to know if they were changed
      // if they were, then we have to determine if they were changed internally
      // or externaly (from parent component)
      if (nextProps.selectedDates !== this.props.selectedDates) {
        this.handleSetCurrentMonth(nextProps, nextState);
      }
    }

    /**
     * Method that will set current month
     * atm it's called only when dates are selected externally,
     * it means that dates were selected from parent component and pass as a
     * @argument {Props} nextProps
     * @argument {State} nextState
     */


    /**
     * Method for selecting date range
     * @argument {Date} date
     */


    /**
     * Method for handling date select
     * @argument {Date} date
     */


    /**
     * Method for handling date hover
     * @argument {Date} date
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          visibleMonths = _props.visibleMonths,
          selectedDates = _props.selectedDates,
          disabledDates = _props.disabledDates,
          allowedDates = _props.allowedDates,
          colors = _props.colors,
          className = _props.className,
          classes = _props.classes,
          past = _props.past,
          future = _props.future,
          firstMonth = _props.firstMonth,
          lastMonth = _props.lastMonth,
          showMonthName = _props.showMonthName,
          showWeekDayNames = _props.showWeekDayNames,
          customClasses = _props.customClasses,
          weekDayFormat = _props.weekDayFormat,
          weekDayFormater = _props.weekDayFormater;
      var _state = this.state,
          currentMonth = _state.currentMonth,
          hoveredDates = _state.hoveredDates,
          isFocused = _state.isFocused;


      var mergedColors = (0, _merge2.default)(defaultColors, colors);
      var months = utils.getMonths(firstMonth, lastMonth);

      return React.createElement(
        CalendarWrapper,
        { className: className, visibleMonths: visibleMonths },
        months.length > visibleMonths && React.createElement(
          PrevBtn,
          {
            "data-test": "rdl-prev-button",
            className: classes.button || "",
            onClick: this.handlePrev,
            disabled: currentMonth === 0 || months.length <= visibleMonths,
            colors: mergedColors
          },
          React.createElement(StyledArrowLeft, null)
        ),
        months.length > visibleMonths && React.createElement(
          NextBtn,
          {
            "data-test": "rdl-next-button",
            className: classes.button || "",
            onClick: this.handleNext,
            disabled: currentMonth === (0, _subtract2.default)((0, _length2.default)(months), visibleMonths) || months.length <= visibleMonths,
            colors: mergedColors
          },
          React.createElement(StyledArrowRight, null)
        ),
        React.createElement(
          CalendarMonthWrapper,
          { className: classes.calendarWrapper || "" },
          (0, _map2.default)(function (month) {
            return React.createElement(StyledMonth, {
              key: month,
              month: month,
              CustomTd: _this2.props.CustomTd,
              selectedDates: selectedDates,
              disabledDates: disabledDates,
              allowedDates: allowedDates,
              selectDate: _this2.handleSelect,
              onHover: _this2.handleHover,
              hoveredDates: hoveredDates,
              past: past,
              isFocused: isFocused,
              future: future,
              colors: mergedColors,
              classes: classes,
              showMonthName: showMonthName,
              showWeekDayNames: showWeekDayNames,
              weekDayFormat: weekDayFormat,
              weekDayFormater: weekDayFormater,
              customClasses: utils.filterCustomClasses((0, _startOfMonth2.default)(month), (0, _endOfMonth2.default)(month))(customClasses)
            });
          }, utils.calendarMonthsToRender(visibleMonths, currentMonth, months))
        )
      );
    }
  }]);

  return Calendar;
}(React.PureComponent);

Calendar.defaultProps = {
  disabledDates: [],
  allowedDates: [],
  visibleMonths: 1,
  colors: {},
  className: "",
  classes: {},
  future: true,
  past: true,
  rangeSelect: false,
  showMonthName: true,
  showWeekDayNames: true,
  customClasses: {},
  weekDayFormat: "dd"
};
exports.default = Calendar;