"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _splitEvery = require("ramda/src/splitEvery");

var _splitEvery2 = _interopRequireDefault(_splitEvery);

var _keys = require("ramda/src/keys");

var _keys2 = _interopRequireDefault(_keys);

var _isEmpty = require("ramda/src/isEmpty");

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _map = require("ramda/src/map");

var _map2 = _interopRequireDefault(_map);

var _templateObject = _taggedTemplateLiteral(["\n  display: table-row;\n"], ["\n  display: table-row;\n"]),
    _templateObject2 = _taggedTemplateLiteral(["\n  width: 300px;\n  display: table;\n  border-collapse: collapse;\n"], ["\n  width: 300px;\n  display: table;\n  border-collapse: collapse;\n"]),
    _templateObject3 = _taggedTemplateLiteral(["\n  display: flex;\n  align-items: center;\n  margin: 40px 0 10px;\n"], ["\n  display: flex;\n  align-items: center;\n  margin: 40px 0 10px;\n"]),
    _templateObject4 = _taggedTemplateLiteral(["\n  width: 43px;\n  text-align: center;\n"], ["\n  width: 43px;\n  text-align: center;\n"]),
    _templateObject5 = _taggedTemplateLiteral(["\n  height: 30px;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n"], ["\n  height: 30px;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n"]);

var _react = require("react");

var React = _interopRequireWildcard(_react);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _format = require("date-fns/format");

var _format2 = _interopRequireDefault(_format);

var _getDate = require("date-fns/getDate");

var _getDate2 = _interopRequireDefault(_getDate);

var _isSameMonth = require("date-fns/isSameMonth");

var _isSameMonth2 = _interopRequireDefault(_isSameMonth);

var _CalendarDay = require("./CalendarDay");

var _CalendarDay2 = _interopRequireDefault(_CalendarDay);

var _utils = require("./utils");

var utils = _interopRequireWildcard(_utils);

var _dayHelpers = require("./utils/dayHelpers");

var dayHelpers = _interopRequireWildcard(_dayHelpers);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Week = _styledComponents2.default.div(_templateObject);

var Month = _styledComponents2.default.div(_templateObject2);

var DayNameList = _styledComponents2.default.div(_templateObject3);

var DayName = _styledComponents2.default.span(_templateObject4);

var MonthName = _styledComponents2.default.span(_templateObject5);

var CalendarMonth = function CalendarMonth(_ref) {
  var month = _ref.month,
      selectedDates = _ref.selectedDates,
      disabledDates = _ref.disabledDates,
      allowedDates = _ref.allowedDates,
      selectDate = _ref.selectDate,
      onHover = _ref.onHover,
      hoveredDates = _ref.hoveredDates,
      past = _ref.past,
      future = _ref.future,
      colors = _ref.colors,
      classes = _ref.classes,
      isFocused = _ref.isFocused,
      _ref$className = _ref.className,
      className = _ref$className === undefined ? "" : _ref$className,
      showMonthName = _ref.showMonthName,
      showWeekDayNames = _ref.showWeekDayNames,
      _ref$customClasses = _ref.customClasses,
      customClasses = _ref$customClasses === undefined ? {} : _ref$customClasses,
      CustomTd = _ref.CustomTd,
      weekDayFormat = _ref.weekDayFormat,
      weekDayFormater = _ref.weekDayFormater;

  var toRender = utils.calendarDaysToRender(month);
  var Day = CustomTd || _CalendarDay2.default;
  return React.createElement(
    "div",
    { className: (classes.month && classes.month) + " " + className },
    showMonthName && React.createElement(
      MonthName,
      null,
      (0, _format2.default)(month, "MMMM YYYY")
    ),
    showWeekDayNames && React.createElement(
      DayNameList,
      null,
      (0, _map2.default)(function (day) {
        return React.createElement(
          DayName,
          { key: day },
          weekDayFormater ? weekDayFormater(day) : (0, _format2.default)(day, weekDayFormat)
        );
      }, utils.calendarDayNames(toRender))
    ),
    React.createElement(
      Month,
      null,
      (0, _map2.default)(function (week) {
        return React.createElement(
          Week,
          { key: week },
          (0, _map2.default)(function (day) {
            return React.createElement(Day, {
              key: day,
              isHidden: !(0, _isSameMonth2.default)(month, day),
              number: (0, _getDate2.default)(day),
              value: day,
              selectDate: selectDate,
              onHover: onHover,
              isHovered: dayHelpers.isHovered(day, hoveredDates),
              isSelected: dayHelpers.isSelected(day, selectedDates),
              isDisabled: dayHelpers.isDisabled(day, disabledDates) || !(0, _isEmpty2.default)(allowedDates) && !dayHelpers.isDisabled(day, allowedDates),
              isPast: dayHelpers.isPast(day, new Date()) && !past,
              isFuture: dayHelpers.isFuture(day, new Date()) && !future,
              isFocused: isFocused,
              classes: (0, _keys2.default)(utils.filterCustomClasses(day)(customClasses)),
              colors: colors
            });
          }, week)
        );
      }, (0, _splitEvery2.default)(7, toRender))
    )
  );
};

exports.default = CalendarMonth;