'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isHovered = exports.isDisabled = exports.isSelected = exports.isFuture = exports.isPast = undefined;

var _find = require('ramda/src/find');

var _find2 = _interopRequireDefault(_find);

var _isBefore = require('date-fns/isBefore');

var _isBefore2 = _interopRequireDefault(_isBefore);

var _isAfter = require('date-fns/isAfter');

var _isAfter2 = _interopRequireDefault(_isAfter);

var _isSameDay = require('date-fns/isSameDay');

var _isSameDay2 = _interopRequireDefault(_isSameDay);

var _startOfDay = require('date-fns/startOfDay');

var _startOfDay2 = _interopRequireDefault(_startOfDay);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isPast = exports.isPast = function isPast(day, date) {
  return (0, _isBefore2.default)(day, (0, _startOfDay2.default)(date));
};
/* eslint-disable import/prefer-default-export */
var isFuture = exports.isFuture = function isFuture(day, date) {
  return (0, _isAfter2.default)(day, (0, _startOfDay2.default)(date));
};

var isSelected = exports.isSelected = function isSelected(day, selectedDates) {
  return Boolean((0, _find2.default)(function (selected) {
    return (0, _isSameDay2.default)(selected, day);
  }, selectedDates));
};

var isDisabled = exports.isDisabled = function isDisabled(day, disabledDates) {
  return Boolean((0, _find2.default)(function (disabled) {
    return (0, _isSameDay2.default)(disabled, day);
  }, disabledDates));
};

var isHovered = exports.isHovered = function isHovered(day, hoveredDates) {
  return Boolean((0, _find2.default)(function (hovered) {
    return (0, _isSameDay2.default)(hovered, day);
  }, hoveredDates));
};